<template>
  <b-tab title-link-class="custom-tabs">
    <template #title>
      <b-icon icon="brush"></b-icon> Style
    </template>
        <h3 class="line-header">Style</h3>

    <b-alert v-if="errorTxt !== null" show variant="warning" dismissible>{{errorTxt}}</b-alert>
    <b-row v-if="layer.isWMS()" class="mb-3">
        <b-col cols="6">
        <b-checkbox
          v-model="layer.useSldBody" switch>
          Utiliser le style défini ici pour les requêtes WMS.<br>
          <i class="text-danger">Attention ceci va surcharger le style du serveur
              en utilisant le paramètre SLD_BODY</i>
        </b-checkbox>
        </b-col>
      <b-col cols="6">
      <b-alert variant="info" show dismissible v-if="geometryTypeNotDefined" class="text-center">
        Attention le type de géométrie n'est pas défini, merci de le préciser<br/><br/>
        <b-select v-model="layer.geometryType" :options="geometryTypeList" class="w-50"></b-select>
      </b-alert>
      </b-col>
    </b-row>
    <SingleStyleDefinition :layer="layer" :styleDefinition="layer.style"/>
  </b-tab>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import GeometryType from '@/models/map-context/GeometryType';
import LayerConfig from '@/models/map-context/LayerConfig';
import Component from 'vue-class-component';

import BaseComponent from '../../BaseComponent';
import SingleStyleDefinition from '../style/SingleStyleDefinition.vue';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
    SingleStyleDefinition,
  },
})
export default class SingleLayerStyle extends BaseComponent {
  layer!: LayerConfig;

  errorTxt:string|null=null;

  geometryTypeList = [GeometryType.UNDEFINED,
    GeometryType.LINE, GeometryType.POINT, GeometryType.POLYGON];

  mounted() {
    console.log('Style');
  }

  get geometryTypeNotDefined():boolean {
    return this.layer.geometryType === undefined
    || this.layer.geometryType === GeometryType.UNDEFINED;
  }
}
</script>

<style scoped lang="less">
</style>
